(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.module = f()}})(function(){var define,module,exports;return (function(){function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s}return e})()({1:[function(require,module,exports){

const events = {
    update: function(ui) {
        this._updatingRatios = 0;
        this._refreshing = true;
        updateRatios(ui, this);
    },

    onChange_var: function(ui) {
        updateRatios(ui, this);
    },

    onChange_ratio: function(ui) {
        updateRatios(ui, this);
    },

    onRemoteDataChanged: function(ui, data) {
        if (data.dataType !== "columns" || data.levelChanged === false)
            return;

        updateRatios(ui, this);
    }
};

const updateRatios = function(ui, context) {

    if (context._updatingRatios > 0)
        return;

    context._updatingRatios += 1;
    let columnName = ui.var.value();
    let oldRatios = context.cloneArray(ui.ratio.value(), []);
    let promise = context.requestData("column", { columnName: columnName, properties: ["levels"] })
    promise.then(rData => {
        let data = [];
        if (rData.columnFound) {
            let levels = rData.levels;
            
            let totalRatio = levels.length;
            for (let i = 0; i < oldRatios.length; i++)
                totalRatio += oldRatios[i].ratio - 1;

            for (let i = 0; i < levels.length; i++) {
                let ratio = 1;
                if (i < oldRatios.length)
                    ratio = oldRatios[i].ratio;

                let prop = parseFloat(Math.round((ratio / totalRatio) * 1000) / 1000).toFixed(3);

                data.push({ level: levels[i].label, ratio: ratio, proportion: prop });
            }
        }

        ui.ratio.setValue(data);
        context._updatingRatios -= 1;
    });
};

module.exports = events;

},{}],2:[function(require,module,exports){

// This file is an automatically generated and should not be edited

'use strict';

const options = [{"name":"data","type":"Data","description":{"R":"the data as a data frame"}},{"name":"var","title":"Variable","type":"Variable","suggested":["nominal","ordinal"],"permitted":["factor"],"description":{"R":"categorical or ordinal variable of interest\n"}},{"name":"counts","title":"Counts (optional)","type":"Variable","suggested":["continuous"],"default":null,"permitted":["numeric"],"description":{"R":"the counts in `data`\n"}},{"name":"expected","title":"Expected counts","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), whether expected counts should be displayed\n"}},{"name":"bi","title":"Binomial","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), only if there are 2 levels of variable\n"}},{"name":"ciWidth","title":"Likelihood-based confidence interval","type":"Number","min":50,"max":99.9,"default":95,"description":{"R":"a number between 50 and 99.9 (default: 95), width of the confidence intervals to provide\n"}},{"name":"lint","type":"Number","title":"Likelihood interval support level","min":1,"max":10,"default":2,"description":{"R":"a number between 1 and 100 (default: 2) specifying the likelihood support interval width\n"}},{"name":"pll","title":"Likelihood function","type":"Bool","default":false,"description":{"R":"for binomial only: plot the likelihood function displaying observed proportion,  alternative hypothesis and support interval\n"}},{"name":"ratio","title":"Expected Proportions for Hₐ","type":"Array","template":{"type":"Number","min":0,"default":1},"default":null,"description":{"R":"a vector of numbers: the expected proportions\n"}},{"name":"varA","title":"Variance analysis","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), perform variance analysis for null and alternative hypotheses\n"}},{"name":"text","title":"Explanatory text","type":"Bool","default":true,"description":{"R":"`TRUE` (default) or `FALSE`, how to report the results\n"}}];

const view = function() {
    
    

    View.extend({
        jus: "2.0",

        events: [

	],

	update: require('./prop.events').update,

	remoteDataChanged: require('./prop.events').onRemoteDataChanged

    }).call(this);
}

view.layout = ui.extend({

    label: "N Outcomes",
    jus: "2.0",
    type: "root",
    stage: 0, //0 - release, 1 - development, 2 - proposed
    controls: [
		{
			type: DefaultControls.VariableSupplier,
			typeName: 'VariableSupplier',
			persistentItems: false,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "var",
							maxItemCount: 1,
							isTarget: true,
							events: [
								{ execute: require('./prop.events').onChange_var }
							]
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "counts",
							maxItemCount: 1,
							isTarget: true
						}
					]
				}
			]
		},
		{
			type: DefaultControls.LayoutBox,
			typeName: 'LayoutBox',
			margin: "large",
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					cell: {"column":0,"row":0},
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Settings",
							controls: [
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									controls: [
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "expected"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "bi",
											controls: [
												{
													type: DefaultControls.TextBox,
													typeName: 'TextBox',
													name: "ciWidth",
													suffix: "%",
													format: FormatDef.number,
													enable: "(bi)"
												},
												{
													type: DefaultControls.TextBox,
													typeName: 'TextBox',
													name: "lint",
													format: FormatDef.number,
													enable: "(bi)"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "pll",
													enable: "(bi)"
												}
											]
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.LayoutBox,
			typeName: 'LayoutBox',
			margin: "large",
			cell: {"column":1,"row":1},
			stretchFactor: 1,
			horizontalAlignment: "center",
			controls: [
				{
					type: DefaultControls.Label,
					typeName: 'Label',
					label: "Additional Analysis",
					controls: [
						{
							type: DefaultControls.CheckBox,
							typeName: 'CheckBox',
							name: "varA",
							verticalAlignment: "bottom"
						}
					]
				},
				{
					type: DefaultControls.Label,
					typeName: 'Label',
					label: "Additional Options",
					controls: [
						{
							type: DefaultControls.CheckBox,
							typeName: 'CheckBox',
							name: "text"
						}
					],
					verticalAlignment: "bottom"
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Expected Proportions for Hₐ",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.ListBox,
					typeName: 'ListBox',
					name: "ratio",
					showColumnHeaders: true,
					fullRowSelect: true,
					height: "large",
					stretchFactor: 1,
					events: [
						{ execute: require('./prop.events').onChange_ratio }
					],
					columns: [
						{
							name: "level",
							label: "Level",
							headerAlign: "left",
							stretchFactor: 1,
							isVirtual: true,
							maxWidth: 300,
							selectable: false,
							template:
							{
								type: DefaultControls.Label,
								typeName: 'Label'
							}							
						},
						{
							name: "ratio",
							label: "Ratio",
							maxWidth: 50,
							stretchFactor: 0.25,
							selectable: false,
							template:
							{
								type: DefaultControls.TextBox,
								typeName: 'TextBox',
								format: FormatDef.number
							}							
						},
						{
							name: "proportion",
							label: "Proportion",
							maxWidth: 100,
							headerAlign: "right",
							isVirtual: true,
							stretchFactor: 0.5,
							selectable: false,
							template:
							{
								type: DefaultControls.Label,
								typeName: 'Label',
								horizontalAlignment: "right"
							}							
						}
					]
				}
			]
		}
	]
});

module.exports = { view : view, options: options };

},{"./prop.events":1}]},{},[2])(2)
});